#TODO 详细情况可查阅block_show文件
from HPUL.py import*
#TODO 详细情况可查阅block_show文件

world = [["0" for i in range(100)] for j in range(100)] # 世界大小改为100*100,正方体方便计算
CIN : str = "" # 玩家输入
OUTPUT : str = "" # 错误输出
instruct_list=["w","a","s","d","/help"]   #用于储存指令的列表（随时添加）
OUTPUT_list=["指令执行完成","指令执行完成","指令执行完成","指令执行完成","输入w向上移动，a向左移动，s向下移动，d向右移动"]#储存客户端输出语句的列表（随时添加）
PLAYER_DEATH=["你摔死了","你淹死了","你被击杀了"]

class CreateHole:
    def __init__(self):
        self.craters = ["small", "medium", "large"] # 存放陨石的类型
        # 存放数据依次为: 撞击波及的范围,概率,长要求,宽要求
        self.crater_use = {
            "small" : [3, 11, 1, 1],
            "medium" : [5, 7, 3, 3],
            "large" : [7, 2, 5, 5]
        } 

    def crash(self):  # “陨石坑”函数
        _x : int = random.randint(0,39)
        _y : int = random.randint(9,14)
        _long : int = random.randint(1,5)
        _height : int = random.randint(1,5)
        crater : str = ""

        if _long * _height <= 1:
            crater = "small"
        elif _long * _height > 1 and _long * _height <= 9:
            crater = "medium"
        else:
            crater = "large"
        world[_x][_y] = "0"
        # 方圆之内只剩残骸(doge)
        _figure.add(_x,_x + self.crater_use[crater][1],_y,_y + self.crater_use[crater][1],world,"0")
        world[_x + self.crater_use[crater][1]][_y + 1 : _y + 3] = "1"
        world[_x + self.crater_use[crater][1] -1][_y + 1 : _y +3] = "1"
# CreateHole_ = CreateHole()
# CreateHole_.crash()



#以下全为柏林噪声地形生成###################################################
def generate_berlin_noise(width, height, scale=10):
    noise = [[random.random() * scale for _ in range(width)] for _ in range(height)]
    return amap(noise)

def generate_terrain(world, noise, threshold):
    height, width = len(noise), len(noise[0])
    for y in range(height):
        for x in range(width):
            if noise[y][x] > threshold:
                world[y][x] = "1"

def generate_random_seed(width, height):
    seed = [[random.randint(0, 255) for i in range(width)] for j in range(height)]
    return amap(seed)

def apply_bitmap_filter(seed, bitmap_filter_size=3):
    kernel = amap([[1 for i in range(bitmap_filter_size)] for j in range(bitmap_filter_size)]) / (bitmap_filter_size ** 2)
    filtered_seed = amap([[0 for i in range(len(seed[0]))] for j in range(len(seed))])

    for i in range(len(seed) - bitmap_filter_size + 1):
        for j in range(len(seed[0]) - bitmap_filter_size + 1):
            filtered_seed[i:i + bitmap_filter_size, j:j + bitmap_filter_size] += (seed[i:i + bitmap_filter_size, j:j + bitmap_filter_size] * kernel).astype(int)

    return filtered_seed

def generate_berlin_noise_map(width, height, scale=10, threshold=0.6, bitmap_filter_size=3):
    noise = generate_berlin_noise(width, height, scale)
    seed = generate_random_seed(width, height)
    filtered_seed = apply_bitmap_filter(seed, bitmap_filter_size)
    noise_map = filtered_seed / 255.0 * noise
    
    generate_terrain(world, noise_map, threshold)
    
    return world

# 上面提供的修改后的柏林噪声代码

# def display_berlin_noise_map_terminal(world):
#     for row in world:
#         for cell in row:
#             if cell == '1':
#                 sys.stdout.write('\033[30;47m \033[m')  # 白色方块
#             else:
#                 sys.stdout.write('\033[30;42m \033[m')  # 绿色方块
#         sys.stdout.write('\n')

# width = 40  # 地图宽度
# height = 40  # 地图高度
# scale = 10  # 噪声的缩放因子
# threshold = 0.6  # 阈值，控制地形生成
# bitmap_filter_size = 3  # 位图滤波器的大小

# noise_map = generate_berlin_noise_map(width, height, scale, threshold, bitmap_filter_size)
# 显示方法

###########################################################################

Temple_1=[
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"],
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "13", "0", "0", "0", "0", "0", "9"],
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"]
] 

Temple_2 = [
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"],
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"],
    ["9", "10", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "10", "0", "0", "10", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "0", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "10", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "0", "10", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "10", "0", "0", "0", "0", "0", "0", "9"],
    ["9", "0", "0", "0", "10", "0", "13", "0", "0", "0", "0", "0", "9"],
    ["9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9", "9"]
] 
